//------------------------------------------------------------------------------------------------------------------------
// Class       : BP::CL_BP_RobotRider
// Author      : BehemothProgrammer
// Description : Robot rider used in german version
//------------------------------------------------------------------------------------------------------------------------
namespace BP
{
	final class CL_BP_RobotRider : TurokEnemy
	{
		CL_BP_RobotRider(kActor @actor)
		{
			super(actor);
		}
		
		void RiderFireMissiles(kActor @instigator, const float w, const float x, const float y, const float z)
		{
			if(self.GetTarget() is null)
			{
				return;
			}
			
			self.SpawnFx("fx/generic_200.kfx", kVec3(x, y, z));
		}
		
		void RiderFireShots(kActor @instigator, const float w, const float x, const float y, const float z)
		{
			if(self.GetTarget() is null)
			{
				return;
			}
			
			self.SpawnFx("fx/generic_201.kfx", kVec3(x, y, z));
		}

		void GunFire(kActor @instigator, const float w, const float x, const float y, const float z)
		{
			if(self.GetTarget() is null)
			{
				return;
			}

			self.PlaySound("sounds/shaders/generic_8_enemy_human_gunfire.ksnd");
			
			self.SpawnFx("fx/robot_bullet.kfx", kVec3(x, y, z));
		}
		
		void DeathSound(kActor @instigator, const float w, const float x, const float y, const float z)
		{
			switch(Math::RandMax(3))
			{
			case 0:
				self.PlaySound("BP_Addons/sounds/shaders/robotgrunt/human_death_scream_1.ksnd");
				break;
			case 1:
				self.PlaySound("BP_Addons/sounds/shaders/robotgrunt/human_death_scream_2.ksnd");
				break;
			case 2:
				self.PlaySound("BP_Addons/sounds/shaders/robotgrunt/human_death_scream_3.ksnd");
				break;
			}
		}
	};
}
