//------------------------------------------------------------------------------------------------------------------------
// Class       : BP::CL_BP_ScriptObject
// Author      : BehemothProgrammer
// Description : Base class for all actors
//------------------------------------------------------------------------------------------------------------------------
namespace BP
{
	const int OBJ_STATE_NONE = -1;

	abstract class CL_BP_ScriptObject : ScriptObject
	{
		kActor @self;
		int state;
		int prevState;
		float stateStartTime;
		float stateEndTime;
		//------------------------------------------------------------------------------------------------------------------------
		CL_BP_ScriptObject(kActor @actor)
		{
			@self = actor;
			state = OBJ_STATE_NONE;
			prevState = OBJ_STATE_NONE;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnSpawn()
		{
			
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnTick()
		{
			
		}
		//------------------------------------------------------------------------------------------------------------------------
		void SetState(const int newState)
		{
			prevState = state;
			state = newState;
			stateStartTime = BP::Time::FromNow(0.0f);
			stateEndTime = stateStartTime;
			OnStateChange();
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnStateChange()
		{
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
}
