//------------------------------------------------------------------------------------------------------------------------
// Class       : BP::CL_BP_LevelPortal
// Author      : BehemothProgrammer
// Description : The portal is hidden until triggered. Once triggered it will appear and set the sectors area teleport
//				 flag ON. While active it will play a humming teleport sound.
// OnTrigger   : Activates the portal and sets the sectors area teleport flag ON. Is Persistent. Subsequent triggers do nothing.
//
// Parameters  : 
//------------------------------------------------------------------------------------------------------------------------
namespace BP
{
	class CL_BP_LevelPortal : CL_BP_ScriptObject
	{
		//------------------------------------------------------------------------------------------------------------------------
		CL_BP_LevelPortal(kActor @actor)
		{
			super(actor);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnBeginLevel()
		{
			self.Flags() |= AF_HIDDEN | AF_INVINCIBLE;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnRestore()
		{
			self.Flags() |= AF_ACTIVATED;
			self.Flags() &= ~AF_HIDDEN;
			self.RunFxEvent("Portal_Init");
			World.FloodMatchingAreaFlags(self.SectorIndex(), AAF_TELEPORT, true);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnTick() override
		{
			if ((self.Flags() & AF_ACTIVATED) != 0)
			{
				self.PlaySound("sounds/shaders/generic_187.ksnd");
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnActivate()
		{
			self.Flags() &= ~AF_HIDDEN;
			self.RunFxEvent("Portal_Init");
			World.FloodMatchingAreaFlags(self.SectorIndex(), AAF_TELEPORT, true);
			self.MarkPersistentBit(false);
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
}
