#include "BP_Addons/scripts/BP_Common_Shared.cpp"

//------------------------------------------------------------------------------------------------------------------------
// Tick Cinema Camera Movement
//------------------------------------------------------------------------------------------------------------------------
$script 50000 //SCRIPT_CINEMA_CAMERA_MOVE
{
	Camera.origin = BP::Math::SmoothStepVec3(BP::Cinema::camLerpFrom, BP::Cinema::camLerpTo, BP::Cinema::camLerpTime / BP::Cinema::camLerpTotalTime);
	if (BP::Cinema::IsCameraMoveFinished())
		return;
	BP::Cinema::camLerpTime += GAME_DELTA_TIME;
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Tick Cinema User Interrupted
//------------------------------------------------------------------------------------------------------------------------
$script 50001 //SCRIPT_CINEMA_USER_INTERRUPT
{
    if (Camera.UserInterrupted())
    {
		BP::Cinema::Stop(true);
        return;
    }

    $restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Tick Cinema Camera Shake
//------------------------------------------------------------------------------------------------------------------------
$script 50002 //SCRIPT_CINEMA_CAMERA_SHAKE
{
	Camera.Tremor().x = Math::RandRange(-BP::Math::ONEDEGREERAD, BP::Math::ONEDEGREERAD) * BP::Cinema::camShakePower;
    Camera.Tremor().y = Math::RandRange(-BP::Math::ONEDEGREERAD, BP::Math::ONEDEGREERAD) * BP::Cinema::camShakePower;
    Camera.Tremor().z = Math::RandRange(-BP::Math::ONEDEGREERAD, BP::Math::ONEDEGREERAD) * BP::Cinema::camShakePower;
	
	if (BP::Time::Reached(BP::Cinema::camShakeTime))
		return;
		
    delay(0.01f);
    $restart;
}
//------------------------------------------------------------------------------------------------------------------------
