namespace BP { namespace Array
{
	//------------------------------------------------------------------------------------------------------------------------
	bool IndexInRange(const uint length, const int index)
	{
		return index >= 0 && index < int(length);
	}
	//------------------------------------------------------------------------------------------------------------------------
	bool IndexInRange(const int length, const int index)
	{
		return index >= 0 && index < length;
	}
	//------------------------------------------------------------------------------------------------------------------------
	int RandomIndex(const uint length)
	{
		return Math::RandMax(int(length));
	}
	//------------------------------------------------------------------------------------------------------------------------
	int NextIndex(const uint length, int index, const int step = 1)
	{
		index += step;
		if (index >= int(length))
			index = 0;
		
		return index;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Gets a random index value from availIndexs and returns the index value. Removes the element from availIndexs.
	// If availIndexs length is 0 then it gets populated with indexs from 0 to arylength; and will not include lastIndexUsed
	//------------------------------------------------------------------------------------------------------------------------
	int GetUniqueElement(const uint arylength, array<int>& availIndexs, const int lastIndexUsed = -1)
	{
		if (availIndexs.length() == 0)
		{
			int lookupLength = int(arylength);
			for (int i = 0; i < lookupLength; i++)
			{
				if (i != lastIndexUsed)
					availIndexs.insertLast(i);
			}
		}
		int index = RandomIndex(availIndexs.length());
		int aryIndex = availIndexs[index];
		availIndexs.removeAt(index);
		return aryIndex;
	}
	//------------------------------------------------------------------------------------------------------------------------
	kStr ToString(array<int> &ary)
	{
		kStr result;
		if (ary.length() > 0)
		{
			result = "" + ary[0];
			for (uint i = 1; i < ary.length(); i++)
			{
				result += " " + ary[i];
			}
		}
		return result;
	}
	//------------------------------------------------------------------------------------------------------------------------
}}
