namespace BP { namespace Input
{
	uint16 buttons;
	uint16 lastButtons;
	//------------------------------------------------------------------------------------------------------------------------
	void Tick()
	{
		lastButtons = buttons;
		buttons = Player.Buttons();
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the buttons
	//------------------------------------------------------------------------------------------------------------------------
	bool Pressing(uint16 checkButtons)
	{
		return (buttons & checkButtons) == checkButtons;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool WeaponLeftDown()
	{
		return (buttons & BC_WEAPONLEFT) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool WeaponRightDown()
	{
		return (buttons & BC_WEAPONRIGHT) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool AttackDown()
	{
		return ((lastButtons & BC_ATTACK) == 0 && (buttons & BC_ATTACK) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool AttackPress()
	{
		return (buttons & BC_ATTACK) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool JumpDown()
	{
		return ((lastButtons & BC_JUMP) == 0 && (buttons & BC_JUMP) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool JumpPress()
	{
		return (buttons & BC_JUMP) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool ForwardDown()
	{
		return ((lastButtons & BC_FORWARD) == 0 && (buttons & BC_FORWARD) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool BackwardDown()
	{
		return ((lastButtons & BC_BACKWARD) == 0 && (buttons & BC_BACKWARD) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool ForwardPress()
	{
		return (buttons & BC_FORWARD) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool BackwardPress()
	{
		return (buttons & BC_BACKWARD) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool StrafeLeftDown()
	{
		return ((lastButtons & BC_STRAFELEFT) == 0 && (buttons & BC_STRAFELEFT) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool StrafeRightDown()
	{
		return ((lastButtons & BC_STRAFERIGHT) == 0 && (buttons & BC_STRAFERIGHT) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool StrafeLeftPress()
	{
		return (buttons & BC_STRAFELEFT) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button. Does not work with gamepad!
	//------------------------------------------------------------------------------------------------------------------------
	bool StrafeRightPress()
	{
		return (buttons & BC_STRAFERIGHT) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button.
	//------------------------------------------------------------------------------------------------------------------------
	bool MapZoomInDown()
	{
		return ((lastButtons & BC_MAPZOOMIN) == 0 && (buttons & BC_MAPZOOMIN) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true during the frame the user pressed down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool MapZoomOutDown()
	{
		return ((lastButtons & BC_MAPZOOMOUT) == 0 && (buttons & BC_MAPZOOMOUT) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool MapZoomInPress()
	{
		return (buttons & BC_MAPZOOMIN) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true while user is pressing down the button
	//------------------------------------------------------------------------------------------------------------------------
	bool MapZoomOutPress()
	{
		return (buttons & BC_MAPZOOMOUT) != 0;
	}
	//------------------------------------------------------------------------------------------------------------------------	
}}
