namespace BP { namespace Inventory
{
	//------------------------------------------------------------------------------------------------------------------------
	// Returns true if player has the key for the hub.
	// hubID: As defined in defs/mapInfo.txt (default: 1=HUB, 7=Lost Lands)
	// keyBit: 0..31
	//------------------------------------------------------------------------------------------------------------------------
	bool HasKey(const int hubID, const int keyBit)
	{
		int nKeys, remainingKeys, keyBits;
		if (!Game.GetHubKeyInfo(hubID, nKeys, remainingKeys, keyBits))
			return false;

		return ((keyBits & (1 << keyBit)) != 0);
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Count(const int index)
	{
		return BP::GameVar::GetIntFromStringArray(GV_KEY_INVENTORY, index, MAX_INVENTORY);
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Give(const int index, const int amount = 1)
	{
		return BP::GameVar::AddIntToStringArray(GV_KEY_INVENTORY, index, MAX_INVENTORY, amount);
	}
	//------------------------------------------------------------------------------------------------------------------------
	int Take(const int index, const int amount = 1)
	{
		return BP::GameVar::AddIntToStringArray(GV_KEY_INVENTORY, index, MAX_INVENTORY, -amount);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void Reset()
	{
		BP::GameVar::SetString(GV_KEY_INVENTORY, "");
	}
	//------------------------------------------------------------------------------------------------------------------------
}}
