namespace BP { namespace Time
{
	float mapStartTime;
	//------------------------------------------------------------------------------------------------------------------------
	float FromNow(const float timeOffset)
	{
		return GameTime() + timeOffset;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Diff(const float time)
	{
		return Math::Fabs(GameTime() - time);
	}
	//------------------------------------------------------------------------------------------------------------------------
	bool Reached(const float timeTarget)
	{
		return GameTime() >= timeTarget;
	}
	//------------------------------------------------------------------------------------------------------------------------
	float GameTime()
	{
		return BP::GameVar::GetFloat(GV_KEY_GAMETIME);
	}
	//------------------------------------------------------------------------------------------------------------------------
	float MapTime()
	{
		return Diff(mapStartTime);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void SetMapTime()
	{
		mapStartTime = GameTime();
	}
	//------------------------------------------------------------------------------------------------------------------------
	float Normalize(const float from, const float to)
	{
		float length = to - from;
		if (length <= 0.0f)
			return 1.0f;
		
		return BP::Math::Clampf(Diff(from) / length, 0.0f, 1.0f);
	}
	//------------------------------------------------------------------------------------------------------------------------
}}
