#include "scripts/Q/Q_Common_Map.cpp"

enum EnumMapTags
{
	TAG_WARP_CAMPAIGN = 1001,
}

//TIDs
//2601: Warp Difficulty
//1001: Warp Campaign (+ Nightmare Difficulty)
//1002: Message Easy EventLink
//1003: Message Easy
//1004: Message Normal EventLink
//1005: Message Normal
//1006: Message Hard EventLink
//1007: Message Hard
//1008: Message Hardcore EventLink
//1009: Message Hardcore
//1010: Message Episode 1 EventLink
//1011: Message Episode 1
//1012: Message Episode 1b EventLink
//1013: Message Episode 1b
//1014: Message Episode 2 EventLink
//1015: Message Episode 2
//1016: Message Episode 3 EventLink
//1017: Message Episode 3
//1018: Message Episode 4 EventLink
//1019: Message Episode 4
//1020: Message Register EventLink
//1021: Message Register
//1022: Shoot Trigger Episode 4 Plaque
//1023: Message Episode 4 Plaque
//1024: 

//------------------------------------------------------------------------------------------------------------------------
// OnStart
//------------------------------------------------------------------------------------------------------------------------
$script 0
{
	Q::OnMapStart(instigator);

	BP::Music::Play(Q::PATH_MUSIC_TRACK04);
	
	BP::playerPuppet.PlayerFlags() |= PF_PREVENTDEATHCAM;
	BP::Actor::Spawn(Q::AT_DROP_INVISIBLEBACKPACK, BP::playerActor);
	BP::playerActor.Velocity() = kVec3(0.0f, 0.0f, 0.001f);
}
//------------------------------------------------------------------------------------------------------------------------
// OnTick
//------------------------------------------------------------------------------------------------------------------------
$script 1
{
	Q::OnMapTick();
	
	int curShellAmmo = Player.GetAmmo(TW_WEAPON_SHOTGUN);
	if (curShellAmmo < Q::PLAYER_STARTSHELLAMMO)
		Player.GiveWeapon(TW_WEAPON_SHOTGUN, Q::PLAYER_STARTSHELLAMMO - curShellAmmo);
	
	if (BP::Actor::IsDead(BP::playerActor))
	{
		PlayLoop.HandlePlayerDeath(false);
	}

    $restart;
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Easy Portal
//------------------------------------------------------------------------------------------------------------------------
$script 7000
{
	EnterDifficultyPortal(DIFFICULTY_EASY);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Normal Portal
//------------------------------------------------------------------------------------------------------------------------
$script 7001
{
	EnterDifficultyPortal(DIFFICULTY_NORMAL);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Hard Portal
//------------------------------------------------------------------------------------------------------------------------
$script 7002
{
	EnterDifficultyPortal(DIFFICULTY_HARD);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Hardcore Portal
//------------------------------------------------------------------------------------------------------------------------
$script 7003
{
	EnterDifficultyPortal(DIFFICULTY_HARDCORE);
}
//------------------------------------------------------------------------------------------------------------------------
// Entered Episode 1: Dimension of the Doomed
//------------------------------------------------------------------------------------------------------------------------
$script 7004
{
	if (BP::Actor::EnteredArea(BP::playerActor))
	{
		BP::playerActor.Health() = BP::Math::Max(BP::playerActor.Health(), 100);
		BP::GameVar::SetInt(Q::GV_KEY_DIFFICULTY, BP::GameVar::GetInt(Q::GV_KEY_CAMP_DIF));
		PlayLoop.StartWarp(BP::playerActor, Q::SAVETID_E1M1, Q::MAP_E1M1);
	}
}
//------------------------------------------------------------------------------------------------------------------------
void EnterDifficultyPortal(const int difficulty)
{
	if (BP::Actor::EnteredArea(BP::playerActor))
	{
		BP::GameVar::SetInt(Q::GV_KEY_CAMP_DIF, difficulty);
		BP::GameVar::SetInt(Q::GV_KEY_DIFFICULTY, difficulty);
		PlayLoop.StartWarp(BP::playerActor, TAG_WARP_CAMPAIGN, Q::MAP_HUB);
	}
}
//------------------------------------------------------------------------------------------------------------------------
